/*
	  : / 
	      LTK v2
	5  2015  ltagkirov  (   )

 	 , - main  tommy 
*/


#include "hardware.h"


//1111 = 4   , ""
#define STORE_BUTTON_STATE(_BTN) \
	do {\
		if (CHECK_BUTTON(_BTN ## _PIN)) {\
			btn_state_buffer_ ## _BTN |= 1;\
		};\
		if ((btn_state_buffer_ ## _BTN & 0b1111) == 0b1111) {\
			btn_state_ ## _BTN[buttons_num_state] = 1;\
		};\
		if ((btn_state_buffer_ ## _BTN & 0b1111) == 0) {\
			btn_state_ ## _BTN[buttons_num_state] = 0;\
		};\
		btn_state_buffer_ ## _BTN <<= 1;\
	} while (0);

inline void update_buttons_state() {
	buttons_num_state = buttons_num_state^1;//1-num_state

	#ifdef BTN_RESTART_PIN
		STORE_BUTTON_STATE(BTN_RESTART);
	#endif
	#ifdef BTN_RELOAD_PIN
		STORE_BUTTON_STATE(BTN_RELOAD);
	#endif
	#ifdef BTN_MODE_PIN
		STORE_BUTTON_STATE(BTN_MODE);
	#endif
	#ifdef BTN_FIRE_PIN
		STORE_BUTTON_STATE(BTN_FIRE);
	#endif
};


// Input/Output Ports initialization,   ;
void init_device() {

	#ifdef BTN_FIRE_PIN
		INIT_BUTTON (BTN_FIRE_PIN);
	#endif

	#ifdef BTN_RESTART_PIN
		INIT_BUTTON (BTN_RESTART_PIN);
	#endif

	#ifdef BTN_RELOAD_PIN
		INIT_BUTTON (BTN_RELOAD_PIN);
	#endif

	#ifdef BTN_MODE_PIN
		INIT_BUTTON (BTN_MODE_PIN);
	#endif


	#ifdef LED_HIT
		INIT_LED (LED_HIT); 	//   (,   ..)
	#endif

	#ifdef LED_EMPTY
		INIT_LED (LED_EMPTY); //  " "
	#endif

	#ifdef LED_FIRE
		INIT_LED (LED_FIRE);	//   
	#endif


	//  2 => 1
	// 5  2015 ltagkirov

	INIT_OUTPUT (B,3,NORMAL); //  (OC2)
	INIT_OUTPUT (B,2,NORMAL); //   ( OC1B) - 
//	INIT_OUTPUT (B,1,NORMAL); //   ( OC1A) - ,   


	// PD2 (Int0) -     
	INIT_INPUT (D,2);

	// 0 -       (TCNT0 -  )
	TCCR0 = (1<<CS02)|(0<<CS01)|(0<<CS00); // = 256,  8 -  = 31250 
	SFIOR |= (1<<PSR10);	//  
	TIMSK = (1<<TOIE0);		//      0

	//  0 - 31250,  ,  
	//  0,008192.          
	//,   . ..   ,      (- main)
	//     8.
	GICR = (1<<INT0);	//  0
	MCUCR = (0<<ISC01)|(1<<ISC00);	//     

	// Analog Comparator  Off
	// Analog Comparator Input Capture by Timer/Counter 1: Off
//	WDTCR=0x17;	//  WatchDog :  WDCE=1, WDE=0, Time=111(2s)
//	ACSR=0x80;
//	SFIOR=0x02; 




	//    2 -     
	// Fout = /(2*(N+1)) => N = /(2*Fout) - 1;
	//      
	//  OCR2 = F_CPU/CARRIER_FREQ/2-1;


	//  2 => 1
	// 5  2015 ltagkirov
	TCCR1A = 0x00; //     
	TCCR1B = 0x11; //  ,  

	// 	   Phase & Freq Corect PWM
	//  f = Fosc / ( 2 * N * TOP)

	#define	ICR1_VAL	(F_CPU/CARRIER_FREQ/2)

	ICR1H  = 0x00;			//    
	ICR1L  = ICR1_VAL; 		//  =111,   36

	OCR1AH = 0x00;			//        
	OCR1AL = ICR1_VAL >> 2;	//     25% 

	OCR1BH = 0x00;		
	OCR1BL = ICR1_VAL >> 1;	//     50%  (   )


	//-----
	//   .    "":

	//    
	incoming_ir.state = PACKAGE_EMPTY;

	//    
	buttons_num_state	= 0;

	//       .
	//..  
	sei();
};

void main_loop();	//   -    
void init();			// .      / 

int main() {

	init_device();
	init();

	while (1) {
		//  
		update_buttons_state();

		//  
		main_loop();

		// 
		process_timer(&timer_sound);
  };//    while (1)

	return 1;
} //fin
