/**
** 
**  .  main.c
** init_device -  
** enable_xxx_led, disable_xxx_led -   main
** update_buttons_state -     
**      IS_PRESSED  IS_CLICKED.    
** 
**/


// 
#include "config.h"

//
#include "sound.h"

//
#include "timer.h"

//
#include "miles.h"

//---
//
uchar buttons_num_state;

#define USE_BUTTON(_BTN) \
	uchar btn_state_ ## _BTN[2];\
	uchar btn_state_buffer_ ## _BTN;

#define IS_PRESSED(_BTN) (btn_state_ ## _BTN[buttons_num_state])
#define IS_CLICKED(_BTN) (btn_state_ ## _BTN[buttons_num_state] && (!btn_state_ ## _BTN[buttons_num_state^1]))

USE_BUTTON(BTN_RESTART);
USE_BUTTON(BTN_RELOAD);
USE_BUTTON(BTN_MODE);
USE_BUTTON(BTN_FIRE);

//---
//

//-   - enable/disable_xxx_led.      disable_head_led()  DISABLE_LED(LED_HEAD)
#define USE_LED(_PIN, _NAME) \
inline void enable_ ## _NAME ##_led() {\
	ENABLE_LED(LED_ ## _PIN);\
}\
inline void disable_ ## _NAME ##_led() {\
	DISABLE_LED(LED_ ## _PIN);\
}

#define DO_NOT_USE_LED(_NAME) inline void enable_ ## _NAME ##_led() {};inline void disable_ ## _NAME ##_led() {};

//   
#ifdef LED_HEAD
	USE_LED(HEAD, head);
#else
	DO_NOT_USE_LED(head);
#endif

#ifdef LED_FIRE
	USE_LED(FIRE, fire);
#else
	DO_NOT_USE_LED(fire);
#endif

#ifdef LED_EMPTY
	USE_LED(EMPTY, empty);
#else
	DO_NOT_USE_LED(empty);
#endif

