/*
** main.c:  
**
** config -      ;
** sound_notes - ,    
**
** globals -     (uchar = unsigned char  ..);
** hardware -    .  , ,     -     main();
** miles -       .  2    0  ;
** sound -     ,      . 1;
** timer -    0.     .  1/122.
** 
** 
**        .
** - init() -     ;
** - main_loop -	 .    14us,  .
**										  -       ( - ~27ms).
** 
**     :
** -     hardware,     ;
** - led_head  sound -           ( ).
** 
**
**   5  2015  ltagkirov
**   : / 
**       LTK v2
**
**/

// 
#include "hardware.h"

//  
#include "sound_notes.h"


//    (  )
//    (  - Player,  - config)
struct Player {
	uchar id;			//id
	uchar team;		//
	uint health;	//
	uchar alive;	//-
	uchar damage;	// (    )

	uint rounds;	// 
	uint mags;		// 
	uchar mode;		//0 - , 1 -  burst 
	uint burst;		//   
} player;

const struct Player config = {
	CONFIG_ID,
	CONFIG_TEAM,
	CONFIG_HEALTH,
	CONFIG_ALIVE,
	CONFIG_DAMAGE,
	CONFIG_ROUNDS,
	CONFIG_MAGS,
	CONFIG_FIRE_MODE,
	CONFIG_BURSTSIZE
};

//  
const uchar damage_table[16] = {1,2,4,5,7,10,15,17,20,25,30,35,40,50,75,100};



//********************
//   
uchar healthindication_counter;
uchar healthindication_flag;
struct timer timer_healthindication;

//*******************

// 
struct timer timer_fire;
struct timer timer_shock;
struct timer timer_vulnerable;
struct timer timer_flash;
struct timer timer_after_death;

//     
uchar ready_to_fire;
uchar out_of_ammo_playing=FALSE;

//   ,   
//**************************



//  
void flash_health() {
	if ((!player.alive) || (player.rounds==0)) {
		return;
	};

  if (healthindication_counter==0) {
    healthindication_flag = FALSE;
    healthindication_counter = player.health;
    start_timer(&timer_healthindication, 122, flash_health);
    return;
  };

  if (healthindication_flag) {
    healthindication_counter--;
    disable_empty_led();
    healthindication_flag = FALSE;
    start_timer(&timer_healthindication, 30, flash_health);
  } else {
    enable_empty_led();
    healthindication_flag = TRUE;
    start_timer(&timer_healthindication, 50, flash_health);
  };
};



void respawn_player() {
	//  
	player.id			= config.id;
	player.team		= config.team;
	player.health	= config.health;
	player.damage = config.damage;
	player.alive	= TRUE;

	// 
	player.rounds = 0;
	player.mags		= config.mags;
	player.burst	= config.burst;

	// /         ""
	#ifdef BTN_MODE_PIN
		#ifdef SQMODE_SWITCH
			player.mode	= config.mode;
		#endif
	#else
		player.mode		= config.mode;
	#endif


	// 
	stop_timer(&timer_fire);
	stop_timer(&timer_shock);
	stop_timer(&timer_vulnerable);
	stop_timer(&timer_flash);
	stop_timer(&timer_after_death);
	stop_timer(&timer_healthindication);

	// 
	stop_sound();

	//  
	disable_fire_led();
	disable_head_led();

	//, ..    ,     
	enable_empty_led();

	//    
	//     
	play_sound(sound_new_game);

	ready_to_fire = TRUE;
};

//-       
//       ,   
// :  ,    
void fire_done() {
	ready_to_fire = TRUE;
};

// ,   ,   
void reload_weapon_done() {
	player.burst = config.burst;
	player.rounds = config.rounds;

	// ,   " "
	play_sound(sound_reload_done);
	ready_to_fire = TRUE;
	disable_empty_led();

	//****************** 
	healthindication_counter = 0;
	flash_health();
	//*******************
};

void reload_weapon() {
	if (player.mags) {
		player.mags--;

		//      
		if (CONFIG_RELOADTIME) {
			ready_to_fire = FALSE;
			start_timer(&timer_fire, CONFIG_RELOADTIME*122, reload_weapon_done);
			play_sound(sound_reload_begin);
		} else {
			//  ,      
			play_sound(sound_reload_done);
		};
	} else {
		//    -   " "
		play_sound(sound_out_of_ammo);
	};
};

//-        
void disable_fire_led_func() {
	disable_fire_led();
};

void process_fire_buttons() {

	//
	if (IS_CLICKED(BTN_RELOAD)) {			
		reload_weapon();
		return;
	};

	//     
	#ifdef SQMODE_SWITCH
		//  
		if (IS_PRESSED(BTN_MODE)) {
			if (!player.mode) {
				play_sound (sound_beep);
			};
			player.mode = TRUE;
		} else {
			if (player.mode) {
				play_sound (sound_beep_beep);
			};
			player.mode = FALSE;
		};
	#else
		//   
		if (IS_CLICKED(BTN_MODE)) {			
			player.mode = !player.mode;
			if (player.mode) {
				play_sound (sound_beep);
			} else {
				play_sound (sound_beep_beep);
			};
		};
	#endif


	if (IS_PRESSED(BTN_FIRE)) {
		//   
		if (player.rounds>0) {
			if (player.burst>0 || !player.mode) {
				player.rounds--;

				if (player.burst) {
					player.burst--;
				};

				ready_to_fire = FALSE;

				//     
				//122(/)*60(/)/CONFIG_RPS(/) = 7324/CONFIG_RPS ()
				//7324,   7320,      122,  31250/256 ,   122,0703125*60 ~= 7324
				//        ,   ,   .
				start_timer(&timer_fire, 7324/CONFIG_RPS, fire_done);

				//    
				stop_sound();

				//   
				send_ir_fire(player.id, player.team, player.damage);

				//  
				#ifdef FIRE_SOUND_FILE
					play_fire_sound();
				#else
					play_sound(sound_fire);
				#endif
				
				//  
				enable_fire_led();

				//  ,     5  - 0.04
				start_timer(&timer_flash, 5, disable_fire_led_func);
			};
		} else { //  
			enable_empty_led();

			if (CONFIG_AUTORELOAD && (player.mags)) {
				// 
				reload_weapon();
			} else {
				//  ,    " "
				if (!out_of_ammo_playing) {
					out_of_ammo_playing = TRUE;
					play_sound(sound_out_of_ammo);
				};
			};
		};
	} else {
		// "" ,   
		player.burst = config.burst;
		out_of_ammo_playing = FALSE;
	};
};

//-  -        
void flash_afterdeath() {
	play_sound(sound_after_death);
	start_timer(&timer_after_death, 1*122, flash_afterdeath);
};

void kill_player() {
	
	//   ///    ,    
	player.alive = FALSE;

	//  
	play_sound(sound_death);

	//   ,  
	if (CONFIG_FLASH_AFTER_DEATH) {
		start_timer(&timer_after_death, 5*122, flash_afterdeath);
	};
};

//  
void process_ir_hit() {
	//    
	if (player.health <= damage_table[incoming_ir.damage]) {
		kill_player();

	} else {
		//  ,  ,     
		player.health -= damage_table[incoming_ir.damage];
		if (CONFIG_SHOCK_TIME) {
			start_timer(&timer_shock, CONFIG_SHOCK_TIME*122, NULL);
		};
		if (CONFIG_BULLETPROOF_TIME) {
			start_timer(&timer_vulnerable, CONFIG_BULLETPROOF_TIME*122, NULL);
		};
		
		play_sound(sound_hit); 
		

		//****************** 
//		healthindication_counter = 0;
//		flash_health();
		//*******************
	};
};

//  .
void process_ir_command() {
	play_sound(sound_beep_beep);

	if (incoming_ir.bytes[2] != 0xE8) {
		play_sound(sound_nearmiss);
	};

	switch (incoming_ir.bytes[0]) {
		case 0x80:
			player.health += incoming_ir.bytes[1];
			break;
		case 0x81:
			player.mags += incoming_ir.bytes[1];
			break;
		case 0x83:
			switch (incoming_ir.bytes[1]) {
				case 0x00:
				case 0x0B:
					kill_player();
					break;
				case 0x02:
				case 0x04:
				case 0x05:
				case 0x0C:
					respawn_player();
					break;
			};
			break;
	};
};

// 
void init() {
	if (config.alive) {
		//    ,   
		respawn_player(); 
	} else {
		//    
		player.alive = FALSE;

		if (CONFIG_FLASH_AFTER_DEATH) {
			start_timer(&timer_after_death, 1*122, flash_afterdeath);
		};

		play_sound(sound_power_on);
	};
};



// .  .     .
void main_loop() {

	//   " "
	if (IS_CLICKED(BTN_RESTART)) {
		respawn_player();
	};

	//         
	if (player.alive && !timer_shock.active && ready_to_fire) {
		process_fire_buttons();
	};

	//  
	process_timer(&timer_shock);

	//  
	process_timer(&timer_vulnerable);

	//  
	process_timer(&timer_flash);

	process_timer(&timer_fire);
	process_timer(&timer_after_death);

	//*****************************
	// 
 	process_timer(&timer_healthindication);
	//********************************



	//  ,   
	if (incoming_ir.state != PACKAGE_EMPTY) {

		if (incoming_ir.state == PACKAGE_BROKEN) {
			//:       
			//     1 ( )

			if (!(TIMSK & (1<<TOIE2))) {					// 5  2015,   2
	 				if (player.alive==TRUE)               	
							{ play_sound(sound_nearmiss); } //****
			};

		} else {
			if (incoming_ir.state == PACKAGE_COMMAND) {
				process_ir_command();
			} else {
				// ,       
				if ((!timer_vulnerable.active) && (player.alive)) {
					//     
					if ((incoming_ir.id != player.id) || (incoming_ir.team != player.team) || CONFIG_SELFDAMAGE) {
						//        
						if ((incoming_ir.team != player.team) || (CONFIG_FRENDLYFIRE) || (CONFIG_SELFDAMAGE)) {
							process_ir_hit();
						};
					};
				};

			};
		};
		incoming_ir.state = PACKAGE_EMPTY; //,  ,    
	};

};


