/*  
	    2 (PB3)
	      LTK v2
	5  2015  ltagkirov
*/


#include "config.h"

#include "sound.h"
#include "timer.h"

#ifdef FIRE_SOUND_FILE
	#include FIRE_SOUND_FILE
#else
	const unsigned char sound_fire_wav[] PROGMEM = {0};
#endif

uint wav_file_pos;
uchar wav_file_prescailer;

//-    .  wav    ,
//    wav       1.

uchar is_playing_sound=FALSE;

//  
const struct sound *current_sound;

//   
uchar sound_pos;



//  2
ISR (TIMER2_OVF_vect) {
	wav_file_prescailer++;
	if (wav_file_pos == sizeof(sound_fire_wav)) {
		stop_sound();
	} else {
		//8 000 000   (.   play_fire_sound - CS10)
		//   256 -   (. play_fire_sound - WGM10  WGM12)
		//    4 = 7812.5,  8 
		if ((wav_file_prescailer&0b11) == 0) {
			OCR2  = pgm_read_byte(&sound_fire_wav[wav_file_pos]);
			wav_file_pos++;
		};
	};
}




void stop_playing_note() {
	// 
//	TCCR1A = 0;
//	TCCR1B = 0; //: 0x08;

	TCCR2=0x00;
	TCNT2=0x00;

	//    
	DISABLE_OUTPUT (B, 4, NORMAL);
};


//   
void play_current_note() {
	
#ifdef LED_HEAD
	//	     ,     .
	if (current_sound[sound_pos].led) {
		ENABLE_LED(LED_HEAD);
	} else {
		DISABLE_LED(LED_HEAD);
	};
#endif

	if (current_sound[sound_pos].frq) {
	  	OCR2 = current_sound[sound_pos].frq;


  		TCNT2 = 0; 		//   1- 
		TCCR2=0x71;		//   PWM    OC2


//		TCCR1B = 0x0C; //  !
//		TCCR1A = 0x40;
	} else {
		stop_playing_note();
	};
};





void stop_sound() {
	TIMSK &= ~(1<<TOIE2);
	is_playing_sound=FALSE;

	stop_playing_note();
	stop_timer(&timer_sound);//     
};

void next_note() {
	sound_pos++; //   
	play_current_note(); //   

	//  ,   
	if (current_sound[sound_pos].length == 0) {
		stop_sound();
	} else {
		//    
		start_timer (&timer_sound, current_sound[sound_pos].length, next_note);
	};
};




void play_fire_sound() {
	is_playing_sound=FALSE;
//******************************
#ifdef LED_HEAD
  DISABLE_LED(LED_HEAD);
#endif
//*********************************
	stop_timer(&timer_sound);

	wav_file_pos = 0;
	wav_file_prescailer = 0;

	//  

	TCNT2 = 0; 		//   1- 
	TCCR2=0x71;		//   PWM    OC2

//	TCCR1A = (1 << COM1A1) | (1 << WGM10);//| (1 << COM1B1) | (1 << COM1B0) 
//	TCCR1B = (1 << WGM12) | (1 << CS10);
// 	TCNT1 = 0;

	//    8  (.    )
	TIMSK |= 1<<TOIE2;
};




void play_sound(const struct sound *sound) {
	//   
	if (sound[0].length == 0) {
		return;
	};

	TIMSK &= ~(1<<TOIE2); //      
//************************************
#ifdef LED_HEAD
  DISABLE_LED(LED_HEAD);
#endif
//*********************

	//    
	is_playing_sound = TRUE;
	current_sound = sound;
	sound_pos = 0;

	//     
	start_timer (&timer_sound, current_sound[sound_pos].length, next_note);

	//   
	play_current_note();
};


